// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from gazebo_video_monitor_interfaces:srv/SetCamera.idl
// generated code does not contain a copyright notice

#ifndef GAZEBO_VIDEO_MONITOR_INTERFACES__SRV__DETAIL__SET_CAMERA__TRAITS_HPP_
#define GAZEBO_VIDEO_MONITOR_INTERFACES__SRV__DETAIL__SET_CAMERA__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "gazebo_video_monitor_interfaces/srv/detail/set_camera__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'pose'
#include "gazebo_video_monitor_interfaces/msg/detail/pose__traits.hpp"

namespace gazebo_video_monitor_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const SetCamera_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: camera_name
  {
    out << "camera_name: ";
    rosidl_generator_traits::value_to_yaml(msg.camera_name, out);
    out << ", ";
  }

  // member: model_name
  {
    out << "model_name: ";
    rosidl_generator_traits::value_to_yaml(msg.model_name, out);
    out << ", ";
  }

  // member: link_name
  {
    out << "link_name: ";
    rosidl_generator_traits::value_to_yaml(msg.link_name, out);
    out << ", ";
  }

  // member: pose
  {
    out << "pose: ";
    to_flow_style_yaml(msg.pose, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SetCamera_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: camera_name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "camera_name: ";
    rosidl_generator_traits::value_to_yaml(msg.camera_name, out);
    out << "\n";
  }

  // member: model_name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "model_name: ";
    rosidl_generator_traits::value_to_yaml(msg.model_name, out);
    out << "\n";
  }

  // member: link_name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "link_name: ";
    rosidl_generator_traits::value_to_yaml(msg.link_name, out);
    out << "\n";
  }

  // member: pose
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pose:\n";
    to_block_style_yaml(msg.pose, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SetCamera_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace gazebo_video_monitor_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use gazebo_video_monitor_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const gazebo_video_monitor_interfaces::srv::SetCamera_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  gazebo_video_monitor_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use gazebo_video_monitor_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const gazebo_video_monitor_interfaces::srv::SetCamera_Request & msg)
{
  return gazebo_video_monitor_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<gazebo_video_monitor_interfaces::srv::SetCamera_Request>()
{
  return "gazebo_video_monitor_interfaces::srv::SetCamera_Request";
}

template<>
inline const char * name<gazebo_video_monitor_interfaces::srv::SetCamera_Request>()
{
  return "gazebo_video_monitor_interfaces/srv/SetCamera_Request";
}

template<>
struct has_fixed_size<gazebo_video_monitor_interfaces::srv::SetCamera_Request>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<gazebo_video_monitor_interfaces::srv::SetCamera_Request>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<gazebo_video_monitor_interfaces::srv::SetCamera_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace gazebo_video_monitor_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const SetCamera_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: message
  {
    out << "message: ";
    rosidl_generator_traits::value_to_yaml(msg.message, out);
    out << ", ";
  }

  // member: success
  {
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SetCamera_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: message
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "message: ";
    rosidl_generator_traits::value_to_yaml(msg.message, out);
    out << "\n";
  }

  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SetCamera_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace gazebo_video_monitor_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use gazebo_video_monitor_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const gazebo_video_monitor_interfaces::srv::SetCamera_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  gazebo_video_monitor_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use gazebo_video_monitor_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const gazebo_video_monitor_interfaces::srv::SetCamera_Response & msg)
{
  return gazebo_video_monitor_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<gazebo_video_monitor_interfaces::srv::SetCamera_Response>()
{
  return "gazebo_video_monitor_interfaces::srv::SetCamera_Response";
}

template<>
inline const char * name<gazebo_video_monitor_interfaces::srv::SetCamera_Response>()
{
  return "gazebo_video_monitor_interfaces/srv/SetCamera_Response";
}

template<>
struct has_fixed_size<gazebo_video_monitor_interfaces::srv::SetCamera_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<gazebo_video_monitor_interfaces::srv::SetCamera_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<gazebo_video_monitor_interfaces::srv::SetCamera_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<gazebo_video_monitor_interfaces::srv::SetCamera>()
{
  return "gazebo_video_monitor_interfaces::srv::SetCamera";
}

template<>
inline const char * name<gazebo_video_monitor_interfaces::srv::SetCamera>()
{
  return "gazebo_video_monitor_interfaces/srv/SetCamera";
}

template<>
struct has_fixed_size<gazebo_video_monitor_interfaces::srv::SetCamera>
  : std::integral_constant<
    bool,
    has_fixed_size<gazebo_video_monitor_interfaces::srv::SetCamera_Request>::value &&
    has_fixed_size<gazebo_video_monitor_interfaces::srv::SetCamera_Response>::value
  >
{
};

template<>
struct has_bounded_size<gazebo_video_monitor_interfaces::srv::SetCamera>
  : std::integral_constant<
    bool,
    has_bounded_size<gazebo_video_monitor_interfaces::srv::SetCamera_Request>::value &&
    has_bounded_size<gazebo_video_monitor_interfaces::srv::SetCamera_Response>::value
  >
{
};

template<>
struct is_service<gazebo_video_monitor_interfaces::srv::SetCamera>
  : std::true_type
{
};

template<>
struct is_service_request<gazebo_video_monitor_interfaces::srv::SetCamera_Request>
  : std::true_type
{
};

template<>
struct is_service_response<gazebo_video_monitor_interfaces::srv::SetCamera_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // GAZEBO_VIDEO_MONITOR_INTERFACES__SRV__DETAIL__SET_CAMERA__TRAITS_HPP_
