// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from gazebo_video_monitor_interfaces:srv/StopRecording.idl
// generated code does not contain a copyright notice

#ifndef GAZEBO_VIDEO_MONITOR_INTERFACES__SRV__DETAIL__STOP_RECORDING__STRUCT_H_
#define GAZEBO_VIDEO_MONITOR_INTERFACES__SRV__DETAIL__STOP_RECORDING__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'filename'
#include "rosidl_runtime_c/string.h"

/// Struct defined in srv/StopRecording in the package gazebo_video_monitor_interfaces.
typedef struct gazebo_video_monitor_interfaces__srv__StopRecording_Request
{
  /// True to discard the recording
  bool discard;
  /// Filename without extension
  rosidl_runtime_c__String filename;
} gazebo_video_monitor_interfaces__srv__StopRecording_Request;

// Struct for a sequence of gazebo_video_monitor_interfaces__srv__StopRecording_Request.
typedef struct gazebo_video_monitor_interfaces__srv__StopRecording_Request__Sequence
{
  gazebo_video_monitor_interfaces__srv__StopRecording_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} gazebo_video_monitor_interfaces__srv__StopRecording_Request__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'path'
// already included above
// #include "rosidl_runtime_c/string.h"

/// Struct defined in srv/StopRecording in the package gazebo_video_monitor_interfaces.
typedef struct gazebo_video_monitor_interfaces__srv__StopRecording_Response
{
  /// Absolute path to the recording
  rosidl_runtime_c__String path;
  bool success;
} gazebo_video_monitor_interfaces__srv__StopRecording_Response;

// Struct for a sequence of gazebo_video_monitor_interfaces__srv__StopRecording_Response.
typedef struct gazebo_video_monitor_interfaces__srv__StopRecording_Response__Sequence
{
  gazebo_video_monitor_interfaces__srv__StopRecording_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} gazebo_video_monitor_interfaces__srv__StopRecording_Response__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // GAZEBO_VIDEO_MONITOR_INTERFACES__SRV__DETAIL__STOP_RECORDING__STRUCT_H_
